	import * as THREE from 'three';

	// transparent wall
	export function wall(length=3000) {
		const wall = new THREE.Object3D();
		const material = new THREE.MeshBasicMaterial({color: 0xff8080, transparent: true, opacity: 0.2, side: THREE.DoubleSide,});
		const geometry = new THREE.CylinderGeometry(10 /*radiusTop*/, 10 /*radiusBottom*/, length /*height*/, 4 /*radialSegments*/, 2 /*heightSegments*/, false /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const chamberMesh = new THREE.Mesh(geometry, material);
		chamberMesh.rotateX(Math.PI * 0.5);
		chamberMesh.scale.setZ(100);
		chamberMesh.position.setY(500);
		chamberMesh.rotatedX = true;
		wall.add(chamberMesh);
		return wall;
	}
